<%@ taglib uri="http://richfaces.org/a4j" prefix="a4j"%>
<%@ taglib uri="http://richfaces.org/rich" prefix="rich"%>
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://richfaces.ajax4jsf.org/rich" prefix="richfaces"%>
<%@ taglib uri="https://ajax4jsf.dev.java.net/ajax" prefix="ajax"%>
<html>
<head>
<title>my-wire ISPManager</title>
</head>
<body>
<f:view>


	<h:panelGrid columns="2" border="0" rules="" title="logopanelgrid">
		<h:graphicImage value="/images/logo_mywire.jpg" />
		<h:outputText
			value="Angemeldet als #{OverviewBean.ispManagerUser.fname} #{OverviewBean.ispManagerUser.lname}"></h:outputText>
		<rich:spacer height="22"></rich:spacer>
	</h:panelGrid>

	<rich:tabPanel switchType="ajax">

		<rich:tab label="Anschlussverwaltung">
			<rich:panelBar height="540" width="1000" value="Anschlussverwaltung">
				<rich:panelBarItem label="Anschluss-Erstellung">
					<h:panelGrid columns="3">
						<h:outputText>Alle Anschlsse auf NAS erstellen </h:outputText>
						<rich:spacer width="20"></rich:spacer>
						<h:outputText>Anzahl Anschlsse anlegen</h:outputText>
						<rich:comboBox label="interface" value="interface">
							<f:selectItems value="#{OverviewBean.interfaceArray}" />
						</rich:comboBox>
						<rich:spacer width="20"></rich:spacer>
						<rich:inputNumberSpinner id="numberOfInterfacesToCreateSpinner"
							label="#{OverviewBean.numberOfInterfacesToCreate}"
							value="#{OverviewBean.numberOfInterfacesToCreate}" maxValue="99"
							minValue="1" immediate="true">
						</rich:inputNumberSpinner>
					</h:panelGrid>
					<rich:spacer height="10"></rich:spacer>
					<rich:dataGrid value="" var="user" columns="3"
						elements="#{OverviewBean.numberOfInterfacesToCreate}" width="400">
						<rich:panel bodyClass="pbody">
							<f:facet name="header">
								<h:outputText>Erstelle Anschluss</h:outputText>
							</f:facet>
							<h:panelGrid columns="2">
								<h:outputText>IF-Ident: </h:outputText>
								<rich:inplaceInput defaultLabel="Interface-ID"></rich:inplaceInput>
								<h:outputText>IF-Typ: </h:outputText>
								<rich:comboBox label="Typ" value="Typ">

									<!--TODO: Hier muss noch ne Typabfrage rein"-->
								</rich:comboBox>
								<h:outputText>Switch-IP: </h:outputText>
								<rich:inplaceInput defaultLabel="Switch-IP"></rich:inplaceInput>
								<h:outputText>NAS-Name: </h:outputText>
								<rich:comboBox label="interface" value="interface">
									<f:selectItems value="#{OverviewBean.interfaceArray}" />
								</rich:comboBox>
								<h:outputText>Switch-Port: </h:outputText>
								<rich:comboBox label="Switch_port" value="Switch-Port">
									<f:selectItems value="#{OverviewBean.interfaceArray}" />
								</rich:comboBox>
								<h:outputText>IF-Status: </h:outputText>
								<rich:comboBox label="Switch_port" value="Switch-Port">
									<f:selectItems value="#{OverviewBean.interfaceArray}" />
								</rich:comboBox>

							</h:panelGrid>
						</rich:panel>
					</rich:dataGrid>

				</rich:panelBarItem>
				<rich:panelBarItem label="Anschluss-Bearbeitung" id="interChange">
					<rich:effect event="onclick" type="Fade"></rich:effect>
					<rich:effect event="onclick" for="interChange" type="Appear"
						params="delay:3.0,duration:0.5"></rich:effect>
				</rich:panelBarItem>

			</rich:panelBar>
		</rich:tab>

		<rich:tab label="Benutzerverwaltung">
			<rich:panelBar>
				<rich:panelBarItem label="Benutzer erstellen">
					<a4j:form id="createUserParameterForm" ajaxSubmit="true">
						<h:panelGrid columns="3">
							<h:outputText>Alle Nutzer auf NAS erstellen </h:outputText>
							<rich:spacer width="20"></rich:spacer>
							<h:outputText>Anzahl Nutzer anlegen</h:outputText>
							<rich:comboBox label="NAS" value="NAS">
								<f:selectItems value="#{OverviewBean.interfaceArray}" />
							</rich:comboBox>
							<rich:spacer width="20"></rich:spacer>
							<a4j:region>
								<rich:inputNumberSpinner id="numberOfUserToCreateSpinner"
									value="#{OverviewBean.numberOfUserToCreate}" maxValue="99"
									minValue="3" step="3" immediate="true">
									<a4j:support event="onchange"
										process="numberOfUserToCreateSpinner,createCustomerDataGrid"
										reRender="createCustomerDataGrid"></a4j:support>
								</rich:inputNumberSpinner>
							</a4j:region>
						</h:panelGrid>
					</a4j:form>
					<rich:spacer height="10"></rich:spacer>
					<a4j:form id="createUserDataGridForm">
						<rich:dataGrid id="createCustomerDataGrid"
							value="#{OverviewBean.customerList}" var="user" columns="3"
							elements="#{OverviewBean.numberOfUserToCreate}" width="400"
							first="0">
							<a4j:support event="onchange"
												process="createCustomerDataGrid" ajaxSingle="true"
												reRender="createUserValidationTable">
											</a4j:support>
							<a4j:region id="createUserDataGridForm">
								<rich:panel bodyClass="pbody" id="userCreationPanel">
									<f:facet name="header">
										<h:outputText>Daten fr Nutzer</h:outputText>
									</f:facet>
									<h:panelGrid columns="2">
										<h:outputText>Vorname: </h:outputText>
										<rich:inplaceInput id="userCreationNameInplaceInput"
											defaultLabel="Vorname eingeben" value="#{user.fname}"
											required="true">
											<a4j:support event="onchange"
												process="userCreationNameInplaceInput" ajaxSingle="true"
												reRender="createUserValidationTable">
											</a4j:support>
										</rich:inplaceInput>

										<h:outputText>Nachname: </h:outputText>
										<rich:inplaceInput defaultLabel="Nachname eingeben"></rich:inplaceInput>
										<h:outputText>Notizen: </h:outputText>
										<h:inputTextarea value="test"></h:inputTextarea>
										<h:outputText>Interface: </h:outputText>
										<rich:comboBox label="Interface" value="Interface"></rich:comboBox>
										<h:outputText>NAS: </h:outputText>
										<rich:comboBox label="NAS" value="NAS">
											<f:selectItems value="#{OverviewBean.interfaceArray}" />
										</rich:comboBox>
									</h:panelGrid>
								</rich:panel>
							</a4j:region>
						</rich:dataGrid>
					</a4j:form>
					<a4j:region id="createUserValidationTableRegion">
						<rich:dataTable id="createUserValidationTable"
							value="#{OverviewBean.customerList}" var="customer" rows="15">
							<h:column>
								<f:facet name="header">
									<h:outputText value="Vname"></h:outputText>
								</f:facet>
								<h:outputText value="#{customer.fname}"></h:outputText>
							</h:column>
						</rich:dataTable>
					</a4j:region>
				</rich:panelBarItem>

				<rich:panelBarItem label="Benutzer bearbeiten">
				</rich:panelBarItem>
			</rich:panelBar>
		</rich:tab>

		<rich:tab label="NAS-Verwaltung">
			<rich:panelBar>
				<rich:panelBarItem label="NAS-Erstellung">

				</rich:panelBarItem>
				<rich:panelBarItem label="NAS-Bearbeitung">

				</rich:panelBarItem>
			</rich:panelBar>
		</rich:tab>

		<rich:tab label="Suche">
			<h:panelGrid columns="2" border="0" rules=""
				title="searchTabPanelGrid">
				<h:outputLabel value="Suche auf interface:  "></h:outputLabel>
				<rich:comboBox label="interface" value="interface">
					<f:selectItems value="#{OverviewBean.interfaceArray}" />
				</rich:comboBox>
			</h:panelGrid>
		</rich:tab>


		<rich:tab label="Reports">
			<rich:panelBar>
				<rich:panelBarItem label="Events">
					<rich:panel style="width:888px;">
						<f:facet name="header">
							<h:outputText>Anzeigeparameter</h:outputText>
						</f:facet>
						<h:panelGrid columns="6">

							<h:outputLabel value="Interface:  "></h:outputLabel>
							<rich:comboBox label="interface" value="interface">
								<f:selectItems value="#{OverviewBean.interfaceArray}" />
							</rich:comboBox>
							<h:outputLabel value=" Von:  "></h:outputLabel>
							<rich:calendar id="fromDate" disabled="false"></rich:calendar>

							<h:outputLabel value=" Bis:  "></h:outputLabel>
							<rich:calendar id="toDate" disabled="false"></rich:calendar>
						</h:panelGrid>
					</rich:panel>
					<rich:spacer height="11"></rich:spacer>

					<a4j:form>
						<a4j:outputPanel id="eventDataTablePanel">
							<rich:dataTable id="showEventDataTable" width="888"
								value="#{OverviewBean.eventList}" var="eventItem" rows="15">
								<f:facet name="header">
									<h:outputText value="Events"></h:outputText>
								</f:facet>
								<rich:column rendered="true">
									<f:facet name="header">
										<h:outputText value="ID"></h:outputText>
									</f:facet>
									<h:outputText value="#{eventItem.id}" rendered="true"></h:outputText>
								</rich:column>

								<rich:column>
									<f:facet name="header">
										<h:outputText value="Datum">
										</h:outputText>
									</f:facet>
									<h:outputText value="#{eventItem.dateTime}" rendered="true"></h:outputText>
								</rich:column>

								<rich:column sortBy="#{eventItem.code}">
									<f:facet name="header">
										<h:outputText value="Code" />
									</f:facet>
									<h:outputText value="#{eventItem.code}" rendered="true"></h:outputText>
								</rich:column>

								<rich:column sortBy="#{eventItem.nas_ip}">
									<f:facet name="header">
										<h:outputText value="NAS-IP" />
									</f:facet>
									<h:outputText value="#{eventItem.nas_ip}" rendered="true"></h:outputText>
								</rich:column>

								<rich:column>
									<f:facet name="header">
										<h:outputText value="NAS-Name" />
									</f:facet>
									<h:outputText value="#{eventItem.nas_name}"></h:outputText>
								</rich:column>

								<rich:column sortBy="#{eventItem.affected_ip}">
									<f:facet name="header">
										<h:outputText value="betr. IP" />
									</f:facet>
									<h:outputText value="#{eventItem.affected_ip}" rendered="true"></h:outputText>
								</rich:column>

								<rich:column sortBy="#{eventItem.affected_mac}">
									<f:facet name="header">
										<h:outputText value="betr. MAC" />
									</f:facet>
									<h:outputText value="#{eventItem.affected_mac}" rendered="true"></h:outputText>
								</rich:column>

								<rich:column sortBy="#{eventItem.affected_interface}">
									<f:facet name="header">
										<h:outputText value="Betr. IFace" />
									</f:facet>
									<h:outputText value="#{eventItem.affected_interface}"
										rendered="true"></h:outputText>
								</rich:column>

								<rich:column id="place">
									<f:facet name="header">
										<h:outputText value="Betr. Standort" />
									</f:facet>
									<h:outputText value="#{eventItem.affected_location}"
										rendered="true"></h:outputText>
								</rich:column>

								<f:facet name="footer">
									<rich:datascroller id="eventDataTableScroller"
										for="showEventDataTable" renderIfSinglePage="false"></rich:datascroller>
								</f:facet>
							</rich:dataTable>
							<h:outputText value="Keine Events vorhanden."
								rendered="#{empty OverviewBean.eventList}"></h:outputText>
						</a4j:outputPanel>
					</a4j:form>
				</rich:panelBarItem>

				<rich:panelBarItem label="Accounting">

				</rich:panelBarItem>

			</rich:panelBar>
		</rich:tab>

		<rich:tab label="otrs"></rich:tab>

		<rich:tab label="ISPManager-Verwaltung">
			<rich:panelBar>
				<rich:panelBarItem label="ISPManager User anlegen">

				</rich:panelBarItem>
				<rich:panelBarItem label="ISPManager User bearbeiten / lschen">

				</rich:panelBarItem>
			</rich:panelBar>
		</rich:tab>


	</rich:tabPanel>

</f:view>
</body>
</html>