package controller;

import java.sql.Connection;
import java.util.Date;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException; //import com.mysql.jdbc.Connection;

import java.sql.Statement;
import java.util.ArrayList;
import java.util.LinkedList;

import objects.Event;
import objects.Interface;
import objects.User;

/*
 * @author prakti
 * 
 * This class is the one and only class, which reads and writes in the database
 * customerDB at localhost.
 */
public class DBHandler {

	private Connection sqlConnection = null;
	private Statement sqlStatement = null;
	private ResultSet sqlResultset = null;

	private String sqlStatementString = null;

	/**
	 * Default constructor creates a connection to the my-wire database
	 * CustomerDB at localhost.
	 */
	public DBHandler() {

		try {
			Class.forName("com.mysql.jdbc.Driver");
			sqlConnection = DriverManager.getConnection(
					"jdbc:mysql://localhost/customerDB", "ISPManager",
					"eev4eowa");
			sqlStatement = sqlConnection.createStatement();

		} catch (Exception exc) {
			System.out.println("DBH: Connection failed");
			exc.printStackTrace();
		}
		// TODO Auto-generated constructor stub
	}

	/**
	 * Closes the sqlStatement and the database-connection
	 */
	private void closeStatementAndConnection() {
		try {
			this.sqlStatement.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			sqlConnection.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	/**
	 * @author prakti
	 * 
	 *         This method initiates a connection to the my-wire database wich
	 *         contains all data for the ISPManager
	 * 
	 *         range:index.jsp
	 * @return true if login succeeded
	 * @param username
	 *            and password of index.jsp
	 * 
	 */
	public User authLogin(String userName, String passWord)
			throws ClassNotFoundException, SQLException {

		System.out.println("Loginmethode betreten!!");

		try {
			System.out.println("Resultset fill");

			sqlStatementString = "SELECT * FROM users WHERE username =" + "'"
					+ userName + "'";

			sqlResultset = sqlStatement.executeQuery(sqlStatementString);
			System.out.println("Resultset filled");
		} catch (Exception e) {

			System.out.println("resultset/statement error");
			e.printStackTrace();
		}

		while (sqlResultset.next()) {
			System.out.println("\n  " + sqlResultset.getString("password"));
			if (passWord.equals(sqlResultset.getString("password"))) {
				System.out.println("\n true");

				User ispManagerUser = createIspManagerUserInstance(sqlResultset
						.getInt("id"));

				// sqlStatementString = "select id from users where userName ="
				// + "'"
				// + userName + "'";
				// sqlResultset = sqlStatement.executeQuery(sqlStatementString);
				//
				// User ispManagerUser =
				// createIspManagerUserInstance(sqlResultset.getInt("id"));

				return ispManagerUser;
			} else
				return null;
		}

		closeStatementAndConnection();

		return null; // If user-table didnt have any content, the password
		// didnt match.
	}

	/**
	 * @author prakti
	 * @return LinkedList of all interfaces in the database
	 * @throws SQLException
	 */
	public LinkedList showInterfaces() throws SQLException {

		LinkedList<Interface> interfaceList = new LinkedList<Interface>();

		sqlResultset = sqlStatement.executeQuery("SELECT * FROM nas");

		while (sqlResultset.next()) {

			Interface InterfaceItem = new Interface();

			InterfaceItem.setCity(sqlResultset.getString("city"));
			InterfaceItem.setComment(sqlResultset.getString("comment"));
			InterfaceItem.setDns(sqlResultset.getString("dns"));
			InterfaceItem.setId(sqlResultset.getInt("id"));
			InterfaceItem.setIp(sqlResultset.getString("ip"));
			InterfaceItem.setLast_change_by(sqlResultset
					.getInt("last_Change_By"));
			// TODO:
			// InterfaceItem.setLast_change_date(sqlResultset.getDate("last_Change_Date"));
			InterfaceItem.setPostal_code(sqlResultset.getInt("postal_code"));
			InterfaceItem.setStreet(sqlResultset.getString("street"));
			InterfaceItem.setStreet_no(sqlResultset.getInt("street_no"));

			interfaceList.add(InterfaceItem);

			// System.out.println("DBH: Added Interface with name "
			// + InterfaceItem.getDns());

		}

		closeStatementAndConnection();

		return interfaceList;
	}

	/**
	 * Creates ArrayList filled with Events
	 * 
	 * @param from
	 *            Date show events from date
	 * @param to
	 *            Date show events to date
	 * @return ArrayList with event-objects
	 * @throws SQLException
	 */
	public ArrayList<Event> showEvents(Date from, Date to) throws SQLException {

		ArrayList<Event> eventList = new ArrayList<Event>();

		sqlResultset = sqlStatement.executeQuery("SELECT * FROM events");

		while (sqlResultset.next()) {

			Event eventListItem = new Event();

			eventListItem.setId(sqlResultset.getInt("id"));
			eventListItem.setCode(sqlResultset.getInt("code"));
			eventListItem.setNas_ip(sqlResultset.getString("nas_ip"));
			eventListItem.setNas_name(sqlResultset.getString("nas_name"));
			eventListItem.setAffected_interface(sqlResultset
					.getString("affected_interface"));
			eventListItem.setAffected_ip(sqlResultset.getString("affected_ip"));
			eventListItem.setAffected_mac(sqlResultset
					.getString("affected_mac"));
			eventListItem.setAffected_location(sqlResultset
					.getString("affected_location"));

			eventList.add(eventListItem);
			// System.out.println("Eventlistitem " + eventListItem.getId() + " "
			// + eventListItem.getNas_name() + " added ");
		}

		closeStatementAndConnection();

		return eventList;
	}

	/**
	 * Creates a User - object wich lives around a session
	 * 
	 * @param UserId
	 * @return User-Object
	 * @throws SQLException
	 */
	public User createIspManagerUserInstance(int UserId) throws SQLException {

		User ispManagerUser = new User();

		sqlResultset = sqlStatement
				.executeQuery("SELECT * FROM users where id = " + UserId);

		while (sqlResultset.next()) {

			ispManagerUser.setAdmin(sqlResultset.getInt("admin"));
			ispManagerUser.setFname(sqlResultset.getString("fname"));
			ispManagerUser.setId(sqlResultset.getInt("id"));
			ispManagerUser.setLast_change_by(sqlResultset
					.getInt("last_change_by"));
			// ispManagerUser.setLast_change_date(sqlResultset.getString("last_change_date"));
			ispManagerUser.setLname(sqlResultset.getString("lname"));
			ispManagerUser.setNas_id(sqlResultset.getString("nas_id"));
			ispManagerUser.setPassword(sqlResultset.getString("password"));
			ispManagerUser.setUsername(sqlResultset.getString("username"));
		}

		return ispManagerUser;

	}

}